# Инструкция

1. Установить Docker
    - https://www.docker.com/get-started/
1. Создать папку для испытаний
    - `mkdir ~/truapp_prototype_experiments`
1. Перейти в созданную папку
    - `cd ~/truapp_prototype_experiments`
1. Распаковать сюда присланный архив с прототипом приложения TRUAPP
    - `ТРУТЕХ-TRUAPP-prototype-[date].zip` -> `~/truapp_prototype_experiments/truapp-prototype`
1. Склонировать сюда текущий репозиторий
    - `git clone https://trulab.ru/trutex/public/truapp-openlane-demo.git`
1. Склонировать репозиторий OpenLane
    - `git clone https://github.com/The-OpenROAD-Project/OpenLane.git openlane`
1. Перейти в папку репозитория
    - `cd openlane`
1. Переключиться на поддерживаемую версию OpenLane (`2023.12.12`)
    - `git checkout 571581d5b75e4b63afde24df2c94fdcc0613f7f9`
1. Собрать OpenLane
    - `make`
1. Протестировать OpenLane
    - `make test`
1. Перенести OpenLane PDK в более подходящее место
    - `mv ~/.volare ~/truapp_prototype_experiments/openlane_pdk_root`
1. Запустить TRUAPP
    - из `~/truapp_prototype_experiments/truapp-prototype`
1. Открыть настройки
    - нажать на кнопку в левом нижнем углу в виде шестеренки (на панели управления)
1. Там должны быть указаны следующие данные
    - ```json
      {
        "docker": "$HOME/.docker/bin/docker"
        "openlane_path": "$HOME/truapp_prototype_experiments/openlane",
        "openlane_pdk_root_path": "$HOME/truapp_prototype_experiments/openlane_pdk_root",
        "openlane_pdk": "sky130A",
        "openlane_docker_image": "efabless/openlane:571581d5b75e4b63afde24df2c94fdcc0613f7f9-amd64"
      }
      ```
    - "docker" - путь до исполняемого файла докера
    - "openlane_path" - путь до репозитория OpenLane
    - "openlane_pdk_root_path" - путь до OpenLane PDK
    - "openlane_pdk" - используемый OpenLane PDK
    - "openlane_repo" - адрес репозитория OpenLane
    - "openlane_docker_image" - полное название Docker Image используемого в данной версии OpenLane
1. Перейти на панель проекта
    - нажать на верхнюю кнопку на панели управления в виде папки
1. Открыть проект инвертера
    - нажать на кнопку `Open Project`
    - выбрать папку с инвертером `~/truapp_prototype_experiments/truapp-openlane-demo/inverter`
    - доп. информация: если в файловом дереве заместо файлов отображается `loading...`, попробуйте обновить состояние нажав на кнопку со значком обновления в верхней правой части данной панели.
1. Открыть файл с конфигурацией OpenLane - `config.tcl`
1. Перейти на панель инструментов
    - нажать на кнопку со значком ключа на панели управления (4ый по счету сверху)
1. Запустить сборку OpenLane проекта инвертора
    - в секции `OpenLane Stages` нажать на кнопку `All`
    - доп. информация: запустить сборку OpenLane возможно только в том случае, если файл с конфигурацией OpenLane (`config.tcl`) является активной вкладкой
1. После этого автоматически должен открыться экран со списком процессов (его также можно открыть и закрыть вручную нажав на кнопку в виде чемодана на панели управления снизу)
1. В списке процессов должен появиться новый процесс с информацией:
    - ```
      Run Design Stage: All
      inverter/config.tcl
      ```
1. Кликнув по даннму процессу можно перейти на страницу подробной информации о процессе
1. Если во время выполнения процесса произошли какие-либо ошибки, вы должны увидеть их в секции "Output" на данной странице
1. Какие потенциально могут быть ошибки?
    - Не запущен Docker в фоне, без него OpenLane работать не будет
    - Неверно указаны какие-либо из путей в настройках
    - Используется неверная версия OpenLane
1. Результат запуска можно просмотреть здесь
    - `~/truapp_prototype_experiments/truapp-openlane-demo/inverter/runs`

# Собственная версия OpenLane

Теоретически возможно тестирование и с вашей собственной локальной версией OpenLane, для этого необходимо верно указать полное название Docker Image с вашей версией OpenLane (`openlane_docker_image` в настройках).

# Поддерживаемые ОС

Теоретически ПО работает на всех ОС, включая MacOS, Linux и Windows. Но в текущей версии тестировалось только на MacOS.
- MacOS: протестировано, работает
- Linux: различия c MacOS минимальны, поэтому работать должно на 99%
- Windows:
  - пути в настройках будут отличаться (возможно необходимо использовать обратный слэш)
  - исполняемый файл Docker будет находиться где-то сильно в другом месте и должен, скорее всего, иметь расщирение `.exe`
  - есть вероятность других непредвиденных проблем

# Дисклеймер

Данная версия ПО является демонстрационной, было написано около полутора лет назад и стабильная работа не гарантируется. Дизайн также является не финальным и будет существенно отличаться от конечного продукта. Данная версия предоставляется исключительно в ознакомительных целях для демонстрации потенциальной возможности взаимодействия с OpenLane.
